export const colorLegend = (selection, props) => {
  const {
    colorScale,
    circleRadius,
    spacing,
    textOffset,onClick,selectedColorValue
  } = props;

  const backgroundRect=selection.selectAll('rect').data([null]);
  backgroundRect.enter().append('rect').merge(backgroundRect)
  .attr('x',-circleRadius*2)
  .attr('y',-circleRadius*2)
  .attr('rx',circleRadius*2)
  .attr('width',250)
  .attr('height',spacing*colorScale.domain().length+circleRadius*2)
  .attr('fill','#f4c542')
  .attr('opacity',0.4);
  
  
  
  const groups = selection.selectAll('.tick')
    .data(colorScale.domain());
  const groupsEnter = groups
    .enter().append('g')
      .attr('class', 'tick');
  groupsEnter
    .merge(groups)
      .attr('transform', (d, i) =>
        `translate(0, ${i * spacing})`
      )
  .attr('opacity',d=>d===selectedColorValue
       ? 1
      : 0.3 
       
       )
  .on('click',onClick);
  
  
  
  
  
  
  
  
  groups.exit().remove();

  groupsEnter.append('circle')
    .merge(groups.select('circle'))
      .attr('r', circleRadius)
      .attr('fill', colorScale);

  groupsEnter.append('text')
    .merge(groups.select('text'))
      .text(d => d)
      .attr('dy', '0.32em')
      .attr('x', textOffset);
}