import {
  select,
  json,
  tsv,
  geoPath,//data path to svg path
  geoEquirectangular,
  //geoMercator,
  zoom,
  event,
  csv,scaleOrdinal, schemeCategory10,schemeSpectral
} from 'd3';
import { feature } from 'topojson';//convert topojson to geojson

import {colorLegend} from './colorLegend';


const svg = select('svg');


/*let selectcountry=null;
const onClick= id=>{selectcountry=id;
render();};
*/


const projection = geoEquirectangular(); //changed map  
const pathGenerator = geoPath().projection(projection);













const g = svg.append('g');


const colorLegendG=svg.append('g')
    .attr('transform', `translate(30,200)`);

g.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

svg.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform);
}));



const colorScale=scaleOrdinal();
const colorValue=d => d.properties.economy;



let selectedColorValue;

let features;

const onClick=d=>{selectedColorValue=d;
                 render()
                 };

Promise.all([
  //tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
  csv('https://vizhub.com/MukundKhandelwal/datasets/zero_append_part1.csv'),
  json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')//from world atlas
]).then(([tsvData, topoJSONdata]) => {
  
  const rowById = tsvData.reduce((accumulator, d) => {
    accumulator[d.iso_n3] = d;
    return accumulator;
  }, {});
  
 
  const Eco = {}; // economic status of the country
  tsvData.forEach(d => {
    Eco[d.iso_n3] = d.economy;
  });
  
  
  const pb = {}; // primary balance of the country
  tsvData.forEach(d => {
    pb[d.iso_n3] = d.primary_balance;
  });
  
  const countries = feature(topoJSONdata, topoJSONdata.objects.countries);
  
  countries.features.forEach(d=>{
    Object.assign(d.properties, rowById[d.id]);
  });
  
  features=countries.features;
  render();

const render=()={
    colorScale
    .domain(countries.features.map(colorValue))
    .domain(colorScale.domain().sort().reverse())
    .range(schemeSpectral[colorScale.domain().length]);
  
  
  colorLegendG.call(colorLegend, {
      colorScale,
      circleRadius: 10,
      spacing: 25,
      textOffset: 12,
    onClick,
    selectedColorValue
    
    });
  
  
  g.selectAll('path').data(countries.features)
    .enter().append('path')
      .attr('class', 'country')
      .attr('d', pathGenerator)
      .attr('fill',d=>colorScale(colorValue(d )))
    .append('title')
      //.text(detail);
  .text( function(d){return d.properties.name+
    ', ' + pb[d.id] 
    + '\n'+Eco[d.id]; // broader economic position 
  });  
  
};





  

});